// 打开分享链接

import axios from "axios"
// const sizeOf = require('image-size')
// import { CONSTS_MIXED_WORDS } from "../../constant"
import { Disambiguation } from "../../utils/obfuscator"
import localLog from "../../utils/logUtil"
import ProductInfo, { CampaignInfo, MetaInfo, ShareInfo } from "./types"
import { IResInfoModule } from "../temporary_res/resinfo"
import { CommonHttpResult } from "../../utils/http"
// import {
//   getClientIP
// } from '../../utils/getRealIp'
const cfgFileName = process.env.NODE_ENV_CFG || "development"

// eslint-disable-next-line import/no-dynamic-require
const dataJSON = require(`../../config/${cfgFileName}.json`)
localLog(
    "[server]-[config]-[db]-p2 env ",
    String(process.env.NODE_ENV),
    ", cfgFileName ",
    cfgFileName
)
/*
 ** 分享
 */
const index = async (ctx: any) => {
    localLog("==================== campaign_index req.headers.referer =>", ctx.req.headers.referer)
    ctx.set("Cache-Control", "no-cache")
    // 1. 传入参数分析
    const { params, query, querystring, href } = ctx
    // origin = getRealOrigin(origin)
    const { pagedebug } = query
    if (!params || !params.campaignCode || !params.shareCode) {
        ctx.send(200, {
            code: 0,
            message: "props must provide",
        })
        return
    }
    localLog("params.campaignCode || !params.shareCode")
    let { campaignCode } = params
    let { shareCode } = params
    if (campaignCode.length === 3 || campaignCode.length === 9) {
        campaignCode = Disambiguation(campaignCode)
        shareCode = Disambiguation(shareCode)
    }
    // ico分析
    // let icoPath = "/TalkU.ico"
    // if (query.metaRep4) {
    //     icoPath = `/${query.metaRep4}.ico`
    // }
    // 2. campaign信息
    const { productInfo } = dataJSON as { productInfo: ProductInfo }
    let campaignInfo: CampaignInfo | undefined
    let shareInfo: ShareInfo | undefined
    Object.keys(productInfo.campaigns_Dic).forEach((cKey) => {
        const campaignItem = productInfo.campaigns_Dic[cKey]
        if (campaignItem.campaignCode === campaignCode) {
            campaignInfo = campaignItem
            Object.keys(campaignItem.campaign_shares_Dic).forEach((csKey) => {
                const shareItem = campaignItem.campaign_shares_Dic[csKey]
                if (shareItem.shareCode === shareCode) {
                    shareInfo = shareItem
                }
            })
        }
    })
    if (!campaignInfo) {
        ctx.send(500, {
            message: "campaignInfo is not exist.",
        })
        return
    }
    if (!shareInfo) {
        ctx.send(500, {
            message: "shareInfo is not exist.",
        })
        return
    }
    // 4.2 meta信息修改
    const meta: MetaInfo = {
        ...campaignInfo.meta,
        ...shareInfo.shareMetas[0].meta,
    }
    const metaReplaceKeys = Object.keys(query).filter((key) => key.startsWith("metaRep"))
    if (metaReplaceKeys.length > 0) {
        // const iterable = new Map()
        // iterable.set("a", 1)
        // iterable.set("b", 2)
        // iterable.set("c", 3)
        // for (const s of iterable) {
        //     console.log(s)
        // }
        const metaMap = new Map<string, string>()
        metaMap.set("og_title", meta.og_title)
        metaMap.set("description", meta.description)
        metaMap.set("og_image", meta.og_image)
        metaReplaceKeys.forEach((queryKey) => {
            ;["og_title", "description", "og_image"].forEach((metaKey) => {
                if (query[queryKey]) {
                    const regex = new RegExp(`\\{\\{${queryKey}\\}\\}`, "gi")
                    const v = metaMap.get(metaKey)
                    if (v) {
                        metaMap.set(metaKey, v.replace(regex, query[queryKey]))
                    }
                }
            })
        })
        meta.og_title = String(metaMap.get("og_title"))
        meta.description = String(metaMap.get("description"))
        meta.og_image = String(metaMap.get("og_image"))

        if (query.og_title) {
            const regex1 = /{{og_title}}/gi
            meta.og_title = meta.og_title.replace(regex1, query.og_title)
        }
        if (query.og_title) {
            const regex2 = /{{description}}/gi
            meta.description = meta.description.replace(regex2, query.description)
        }
        if (query.og_title) {
            const regex3 = /{{og_image}}/gi
            meta.og_image = meta.og_image.replace(regex3, query.og_image)
        }
    }
    meta.og_imgw = "806" // 185
    meta.og_imgh = "390" // 185
    if (productInfo.productName === "VidNow") {
        if (query.vdimg) {
            meta.og_image = decodeURIComponent(decodeURIComponent(query.vdimg))
        } else if (query.id || query.v) {
            // 从接口中查询对应的视频图片信息
            const vdId = query.id || query.v
            // // 混淆vid
            // let rands = ""
            // for (let i = 0; i < 2; i+=1) {
            //     // 增加两个随机字符
            //     rands += CONSTS_MIXED_WORDS[Math.floor(Math.random() * CONSTS_MIXED_WORDS.length)]
            // }
            const newId = `tp${query.tp}_${vdId}`
            const dbItemRes = await axios.get<CommonHttpResult<IResInfoModule>>(
                `${dataJSON.combineImageAndSaveInfoPrefix}/res/get/${newId}`
            )
            const dbItemRlt = dbItemRes.data
            if (dbItemRlt.success && dbItemRlt.data) {
                if (dbItemRlt.data.iconUrl) meta.og_image = dbItemRlt.data.iconUrl
                if (dbItemRlt.data.title) meta.og_title = dbItemRlt.data.title // + '<br>' + rlt.data.actor
                if (dbItemRlt.data.description) meta.description = dbItemRlt.data.description

                localLog(
                    "[controllers]-[campaign]-[share]-[index] get meta info result =>",
                    "[",
                    String(JSON.stringify(dbItemRlt.data).length),
                    "]",
                    meta.og_title
                )
            }
            localLog("get meta info result =>", JSON.stringify(dbItemRlt))
        }
    }

    // // 按照去查询
    // if (meta.og_image && meta.og_image.indexOf("/img") === 0) {
    //     meta.og_image = meta.og_image
    // }
    // meta.og_image_scu = meta.og_image
    const htmlUrlPcs = href.split("?")
    if (htmlUrlPcs[0].indexOf(".html") === -1) {
        meta.og_url = `${getRealOrigin(htmlUrlPcs[0])}.html?${htmlUrlPcs[1] || ""}`
    } else {
        meta.og_url = `${getRealOrigin(htmlUrlPcs[0])}?${htmlUrlPcs[1] || ""}`
        // return 'not implement error'
    }
    // 其余空参数
    // const channel = ""
    // const language = ""
    // const countryCode = ""
    // const moduleName = ""
    // const inviteKey = ""
    // const inviteKeyD = ""
    // const inviteKeyID = ""
    // const pid = ""
    // const fullPath = ""
    let originActUrl = ""
    if (shareInfo.shareOriginUrl) {
        if (shareInfo.shareOriginUrl instanceof Array) {
            const idx = Math.floor(Math.random() * 2)
            originActUrl = shareInfo.shareOriginUrl[idx]
        } else {
            originActUrl = shareInfo.shareOriginUrl
        }
    } else {
        originActUrl = campaignInfo.campaignUrl
    }

    // const tmp111 = {
    //     pageDebug: pagedebug || 0,
    //     querystring,
    //     icoPath,
    //     meta,
    //     channel,
    //     language,
    //     countryCode,
    //     moduleName,
    //     inviteKey,
    //     inviteKeyD,
    //     inviteKeyID,
    //     pid,
    //     fullPath,
    //     originActUrl,
    //     // type: activityEntity.type,
    //     isDownLoad: true,
    //     pageType: shareInfo.pageType, // 1: 普通页面流程  2：可以在活动页面打不开的情况下，显示下载页面 3：在特定的浏览器中显示下载引导文案
    //     type: 1, // 1 : 下载活动页面 2: 下载
    //     ignoreRetrieve: shareInfo.ignoreRetrieve, // 是否忽略上报(vidnow唯一标识)
    // }
    // meta.description
    // meta.og_title
    // meta.og_image
    // meta.og_site_name
    // meta.og_url
    // meta.og_type
    // meta.og_imgw
    // meta.og_imgh
    console.log(
        "[controllers]-[campaign]-[share]-[index] meta",
        // JSON.stringify(meta),
        JSON.stringify({
            description: meta.description,
            og_title: meta.og_title,
            og_image: meta.og_image,
            og_site_name: meta.og_site_name,
            og_url: meta.og_url,
            og_type: meta.og_type,
        })
    )
    switch (+shareInfo.shareType) {
        case 100:
        default:
            await ctx.render("./share/share_blank", {
                pageDebug: pagedebug || 0,
                querystring,
                // icoPath,
                meta,
                // channel,
                // language,
                // countryCode,
                // moduleName,
                // inviteKey,
                // inviteKeyD,
                // inviteKeyID,
                // pid,
                // fullPath,
                originActUrl,
                // type: activityEntity.type,
                // isDownLoad: true,
                pageType: shareInfo.pageType, // 1: 普通页面流程  2：可以在活动页面打不开的情况下，显示下载页面 3：在特定的浏览器中显示下载引导文案
                // type: 1, // 1 : 下载活动页面 2: 下载
                // ignoreRetrieve: shareInfo.ignoreRetrieve, // 是否忽略上报(vidnow唯一标识)
            })
            break
    }
}
function getRealOrigin(fakeUrl: string) {
    if (process.env.NODE_ENV === "production") {
        // 微服务 假origin的问题
        const sets = dataJSON.productInfo.domainSet
        // ["http://d1o7xq.2usrqwl1z.com",
        // "http://dhem3m.2usrqwl1z.com",
        // "http://d30grv.2usrqwl1z.com",
        // "http://dy5axt.2usrqwl1z.com",
        // "http://d3fgr4.2usrqwl1z.com",
        // "https://d1o7xq.2usrqwl1z.com",
        // "https://dhem3m.2usrqwl1z.com",
        // "https://d30grv.2usrqwl1z.com",
        // "https://dy5axt.2usrqwl1z.com",
        // "https://d3fgr4.2usrqwl1z.com"]
        for (let i = 0; i < sets.length; i += 1) {
            if (fakeUrl.indexOf(sets[i]) > -1) {
                return fakeUrl.replace(/:[0-9]{1,}/, "")
            }
        }
    }
    return fakeUrl
}

// console.log('tttttttttttttttttt11111111111111111111 => ', getRealOrigin('http://localhost:3012'))

// console.log('tttttttttttttttttt2222222222222222222 => ', getRealOrigin('http://178.128.110.30:3012'))

// console.log('tttttttttttttttttt3333333333333333333 => ', getRealOrigin('http://d30grv.2usrqwl1z.com:3012'))

// console.log('tttttttttttttttttt3333333333333333333 => ', getRealOrigin('http://d30grv.2usrqwl1z.com:3012/s2hbm/hsm/lfuf/xv'))
export default {
    index,
}
