import postUtil from "../../utils/post"
import ResModel from "../../modules/resinfo"
// import { IResInfoOrmObject } from "../../schema/resinfo"
import { IResInfo2 } from "../../schema/resinfo2"
import { CommonHttpResult } from "../../utils/http"

// import * as UserController from '../user/login'
// import { localLog } from "../../utils/logUtil";
export interface IResInfoModule {
    id: string
    title: string
    description: string
    description2?: string
    iconUrl: string
}

/**
 * ResInfo的增删查改
 */
export default class resinfoController {
    static async forAliveTest() {
        // 保活测试
        // let res = await ResModel.default.getTempResDetail("unknownId")

        return true
    }

    /**
     * 获取资源信息
     * */
    static async getResInfo(resId: string) {
        // let result = await UserController.default.verify(ctx, next)
        // if(!result.success) {
        //     ctx.body = result
        //     return
        // }
        console.log("去获取单个实体")
        const item = await ResModel.getTempResDetail(resId)
        console.log("item str.length =>", JSON.stringify(item).length)
        if (item) {
            return {
                id: item.id,
                title: item.val1,
                description: item.val2,
                iconUrl: item.val3,
                description2: item.val4,
            } as IResInfoModule
        }
        return undefined
    }

    /**
     * 分页查询资源信息
     */
    static getList = async (ctx: any) => {
        const dataStr = await postUtil.getPostData(ctx)
        const data = JSON.parse(dataStr)

        console.log("去获取列表")
        const rlt = await ResModel.getList(data.pageIdx, data.pageSize)
        try {
            ctx.body = {
                Result: 1,
                success: true,
                code: 1,
                data: {
                    total: rlt.count,
                    list: rlt.rows,
                    pageIdx: data.pageIdx,
                    pageSize: data.pageSize,
                },
            } as CommonHttpResult<any>
        } catch (e: any) {
            ctx.body = {
                Result: 0,
                success: false,
                code: 0,
                message: e.message,
            } as CommonHttpResult<any>
        }
    }

    /**
     * 预存单个资源信息
     * */
    static async saveResInfo(data: IResInfoModule) {
        const dateStamp = new Date().getTime()
        // 一共 1+8*2=16 个字段, 现只使用 1+3*2=6 个字段

        const postData = {
            id: data.id,
            key1: "title",
            val1: data.title,
            key2: "desc",
            val2: data.description,
            key3: "iconUrl",
            val3: data.iconUrl,
            createTime: dateStamp,
            updateTime: dateStamp,
            key4: "desc2",
            val4: data.description2,
            key5: "",
            val5: "",
            key6: "",
            val6: "",
            key7: "",
            val7: "",
            key8: "",
            val8: "",
        } as IResInfo2
        try {
            // console.log("去创建", JSON.stringify(postData))
            console.log("去创建")
            await ResModel.createTempRes(postData)
            console.log("创建完成")
            return {
                Result: 1,
                success: true,
                code: 1,
                data: true,
                message: "",
            } as CommonHttpResult<boolean>
        } catch (e: any) {
            console.log("创建失败")
            return {
                Result: 0,
                success: false,
                code: 0,
                message: e.message,
                data: postData,
            } as CommonHttpResult<any>
        }
    }

    // static removeResInfo = async (ctx: any) => {
    //     const dataStr = await getPostData(ctx)

    //     const data = JSON.parse(dataStr)
    //     ctx.body = await resinfoController._removeResInfo(data)
    // }

    static async removeResInfo(data: IResInfoModule) {
        try {
            console.log("去删除")
            await ResModel.removeTempRes(data)
            return {
                Result: 1,
                success: true,
                code: 1,
                data: true,
            } as CommonHttpResult<boolean>
        } catch (e: any) {
            return {
                Result: 0,
                success: false,
                code: 0,
                message: e.message,
                data,
            } as CommonHttpResult<any>
        }
    }
}
