// 引入刚刚在第五点建立连接mysql数据库的db.js文件
// 引入上一步的文章数据表模型文件
// import ResInfo, { IResInfoOrmObject } from "../schema/resinfo"

import ResInfo2, { IResInfo2 } from "../schema/resinfo2"

// const db = require("../config/db")
// 引入Sequelize对象
// const SequelizeMdl = db.sequelize

class ResModel {
    /**
     * 创建Temp Res数据
     * @param data
     * @returns {Promise<*>}
     */
    static async createTempRes(data: IResInfo2) {
        // console.log("创建Temp Res数据=>", JSON.stringify(data))
        const entity = await ResInfo2.build(data)
        const rlt = await entity.save()
        return rlt
    }

    static async removeTempRes(data = { id: "" }) {
        const rlt = await ResInfo2.destroy({
            where: {
                id: data.id,
            },
        })
        return rlt
    }

    /**
     * 查询取文章详情数据
     * @param id  资源id
     * @returns {Promise<Model>}
     */
    static async getTempResDetail(id: string) {
        const rlt = await ResInfo2.findOne({
            where: {
                id,
            },
        })
        return rlt
    }

    /**
     * 分页查询
     * @param pageIdx 页索引
     * @param pageSize 页大小
     * @returns {Promise<Model>}
     */
    static async getList(pageIdx: number, pageSize: number) {
        let offset = (pageIdx - 1) * pageSize
        if (offset < 0) offset = 0

        const rlt = await ResInfo2.findAndCountAll({
            // where: {
            //   title: {
            //     [Op.like]: 'foo%'
            //   }
            // },
            offset,
            limit: pageSize,
        })
        return rlt
    }
}

export default ResModel
