import campaignRouter from "./campaign"
import campaignV2Router from "./campaignv2"
import apiRouter from "./api"
import userRouter from "./user"
import resInfoRouter from "./temp_res"

const compose = require("koa-compose")
const Router = require("koa-router")

const router = new Router()

router.get("/demo", async (ctx: any) => {
    await ctx.render("./share/default", {
        title: "sever interface test",
        description: "this is a page of sever interface test",
    })
})

// 已作废
router.use("/sh(.*)", campaignRouter.routes(), campaignRouter.allowedMethods())
router.use("/s2h(.*)", campaignV2Router.routes(), campaignV2Router.allowedMethods())
router.use("/api", apiRouter.routes(), apiRouter.allowedMethods())
router.use("/user", userRouter.routes(), userRouter.allowedMethods())
router.use("/res", resInfoRouter.routes(), resInfoRouter.allowedMethods())
router.get("/(.*)", async (ctx: any) => {
    ctx.body = { status: 404 }
})

export default function routes() {
    return compose([router.routes(), router.allowedMethods()])
}
