import ResCtl from "../controllers/temporary_res/resinfo"
import { combineImageAndSaveInfo } from "../controllers/campaign/img"
import localLog from "../utils/logUtil"
import postUtil from "../utils/post"
import { CommonHttpResult } from "../utils/http"

const Router = require("koa-router")

const router2 = new Router()

/**
 * 保存预存资源的信息
 * */
router2.post("/saveResInfo", async (ctx: any) => {
    const dataStr = await postUtil.getPostData(ctx)
    const data = JSON.parse(dataStr)
    ctx.body = await ResCtl.saveResInfo(data)
})

/**
 * 分享图片
 * */
router2.post("/shImg", combineImageAndSaveInfo)

/**
 * 查询单个预存资源的信息
 */
router2.post("/getList", ResCtl.getList)

/**
 * 查询单个预存资源的信息
 */
router2.get("/get/:resId", async (ctx: any) => {
    const { resId } = ctx.params
    localLog("getResInfo resId=>", resId)
    const data = await ResCtl.getResInfo(resId)
    if (data) {
        ctx.body = {
            Result: 1,
            success: true,
            code: 1,
            data,
            message: "",
        } as CommonHttpResult<any>
    } else {
        ctx.body = {
            Result: 0,
            success: false,
            code: 0,
            message: "",
        } as CommonHttpResult<any>
    }
})

/**
 * forAliveTest
 */
router2.get("/forAliveTest", async (ctx: any) => {
    ctx.body = {
        Result: 1,
        success: true,
        code: 1,
        data: await ResCtl.forAliveTest(),
    } as CommonHttpResult<any>
})

export default router2
