import { createCanvas, Image, CanvasRenderingContext2D } from "canvas"
// import { localLog } from "./logUtil";
// function setGaussianBlurCanvas1({
//   cvsContext: any,
//   tarWidth: number,
//   tarHeight: number,
//   image: Image
// }) {
//   const { width, height } = image;// 获取图片宽高

//   let dwImg1 = tarWidth
//   let dhImg1 = parseInt(height * tarWidth / width)
//   let dxImg1 = -1 * parseInt((dwImg1 - tarWidth) / 2)
//   let dyImg1 = -1 * parseInt((dhImg1 - tarHeight) / 2)

//   let scaleRate = 1
//   let tarWidth_filter = parseInt(tarWidth * scaleRate)
//   let tarHeight_filter = parseInt(tarHeight * scaleRate)
//   const _filterCanvas = createCanvas(tarWidth_filter, tarHeight_filter) // 按照微信官方要求，长宽比5:4
//   let dwImg1_filter = parseInt(dwImg1 * scaleRate)
//   let dhImg1_filter = parseInt(dhImg1 * scaleRate)
//   const _filterContext = _filterCanvas.getContext('2d')
//   let dxImg1_filter = -1 * parseInt((dwImg1_filter - tarWidth * scaleRate) / 2)
//   let dyImg1_filter = -1 * parseInt((dhImg1_filter - tarHeight * scaleRate) / 2)
//   localLog({ dwImg1, dhImg1, dxImg1, dyImg1 }, { dwImg1_filter, dhImg1_filter, dxImg1_filter, dyImg1_filter })
//   // _filterContext.globalAlpha = .2 //调节透明度
//   _filterContext.filter = "blur(40px)"
//   _filterContext.drawImage(image, dxImg1_filter, dyImg1_filter, dwImg1_filter, dhImg1_filter)

//   cvsContext.drawImage(_filterCanvas, 0, 0, dwImg1_filter, dhImg1_filter, 0, 0, dwImg1, dhImg1)
// }

// async function setGaussianBlurCanvas2({
//   cvsContext,
//   tarWidth,
//   tarHeight,
//   image
// }) {

//   const { width, height } = image;// 获取图片宽高

//   let dwImg1 = tarWidth
//   let dhImg1 = parseInt(height * tarWidth / width)
//   let dxImg1 = -1 * parseInt((dwImg1 - tarWidth) / 2)
//   let dyImg1 = -1 * parseInt((dhImg1 - tarHeight) / 2)
//   let tmpCanvas = createCanvas(tarWidth, tarHeight)
//   let tmpContext = tmpCanvas.getContext("2d")
//   tmpContext.drawImage(image, dxImg1, dyImg1, dwImg1, dhImg1)

//   let imgData = tmpContext.getImageData(0, 0, dwImg1, dhImg1)
//   let iAr = imgData.data
//   let pW = parseInt(tarWidth / 2) // pixel width
//   let pH = parseInt(tarHeight / 2) // pixel height
//   // let pP = 16 // pixel of point
//   let niAr = [] //
//   for (let i = 0; i < iAr.length; i++) { //i+=4
//     let j = 0
//     // for(let j = 0; j < 3; j++) {
//     let ard = [] //around
//     let lt = iAr[i + j - pW - 4] // left top
//     if (lt) ard.push(lt)
//     let ct = iAr[i + j - pW] // center top
//     if (ct) ard.push(ct)
//     let rt = iAr[i + j - pW + 4] // right top
//     if (rt) ard.push(rt)
//     let lc = iAr[i + j - 4] // left center
//     if (lc) ard.push(lc)
//     let rc = iAr[i + j + 4] // right center
//     if (rc) ard.push(rc)
//     let bl = iAr[i + j + pW - 4] // bottom center
//     if (bl) ard.push(bl)
//     let bc = iAr[i + j + pW] // bottom center
//     if (bc) ard.push(bc)
//     let br = iAr[i + j + pW + 4] // bottom center
//     if (br) ard.push(br)

//     niAr[i] = parseInt(eval(ard.join("+")) / ard.length)
//     // }

//     // niAr[i + 3] = iAr[i + 3]
//   }

//   let newImageData = new ImageData(new Uint8ClampedArray(niAr), tarWidth, tarHeight)// JSON.parse(JSON.stringify(imgData))
//   newImageData.data = niAr
//   cvsContext.putImageData(newImageData, 0, 0)
// }

import stackBlurCanvas from "./imgUtil"

type GaussianBlurParam = {
    cvsContext: CanvasRenderingContext2D
    tarWidth: number
    tarHeight: number
    image: Image
}
async function setGaussianBlurCanvas3(param: GaussianBlurParam) {
    const { cvsContext, tarWidth, tarHeight, image } = param
    const { width, height } = image // 获取图片宽高

    const dwImg1 = tarWidth
    const dhImg1 = Math.floor((height * tarWidth) / width)
    const dxImg1 = -1 * Math.floor((dwImg1 - tarWidth) / 2)
    const dyImg1 = -1 * Math.floor((dhImg1 - tarHeight) / 2)
    const tmpCanvas = createCanvas(tarWidth, tarHeight)
    const tmpContext = tmpCanvas.getContext("2d")
    tmpContext.drawImage(image, dxImg1, dyImg1, dwImg1, dhImg1)

    const imgData = tmpContext.getImageData(0, 0, dwImg1, dhImg1)
    // const pW = Math.floor(tarWidth / 2) // pixel width
    // const pH = Math.floor(tarHeight / 2) // pixel height

    const newImageData = stackBlurCanvas.stackBlurCanvasRGBA(imgData, tarWidth, tarHeight, 50)

    cvsContext.putImageData(newImageData, 0, 0)
}

export default { setGaussianBlurCanvas3 }
