import chalk from "chalk"

const dateTimeFmt = (formatStr: string, dtNumber: number) => {
    const dt = new Date(dtNumber)

    const Y = dt.getFullYear()
    const YS = String(Y)

    const M = dt.getMonth() + 1
    let MS = String(M)
    if (MS.length === 1) MS = `0${MS}`

    const D = dt.getDate()
    let DS = String(D)
    if (DS.length === 1) DS = `0${DS}`

    const H = dt.getHours()
    let HS = String(H)
    if (HS.length === 1) HS = `0${HS}`

    const m = dt.getMinutes()
    let mS = String(m)
    if (mS.length === 1) mS = `0${mS}`

    const s = dt.getSeconds()
    let sS = String(s)
    if (sS.length === 1) sS = `0${sS}`
    return formatStr
        .replace(/[Yy]{1,}/, YS)
        .replace(/M{1,}/, MS)
        .replace(/[Dd]{1,}/, DS)
        .replace(/[Hh]{1,}/, HS)
        .replace(/m{1,}/, mS)
        .replace(/[Ss]{1,}/, sS)
}

export function localLogErr(...str: string[]) {
    const dateStr = dateTimeFmt("yyyy-MM-dd hh:mm:ss", Date.now())
    console.log(chalk.red(`[${dateStr}] ${str.join("")}`))
}

export default function localLog(...str: string[]) {
    const dateStr = dateTimeFmt("yyyy-MM-dd hh:mm:ss", Date.now())
    console.log(chalk.yellow(`[${dateStr}] ${str.join("")}`))
}
