// const mime = require("mime");
const mimeArr = [
    { sufix: ".*", mime: "application/octet-stream" },
    { sufix: ".tif", mime: "image/tiff" },
    { sufix: ".001", mime: "application/x-001" },
    { sufix: ".301", mime: "application/x-301" },
    { sufix: ".323", mime: "text/h323" },
    { sufix: ".906", mime: "application/x-906" },
    { sufix: ".907", mime: "drawing/907" },
    { sufix: ".a11", mime: "application/x-a11" },
    { sufix: ".acp", mime: "audio/x-mei-aac" },
    { sufix: ".ai", mime: "application/postscript" },
    { sufix: ".aif", mime: "audio/aiff" },
    { sufix: ".aifc", mime: "audio/aiff" },
    { sufix: ".aiff", mime: "audio/aiff" },
    { sufix: ".anv", mime: "application/x-anv" },
    { sufix: ".asa", mime: "text/asa" },
    { sufix: ".asf", mime: "video/x-ms-asf" },
    { sufix: ".asp", mime: "text/asp" },
    { sufix: ".asx", mime: "video/x-ms-asf" },
    { sufix: ".au", mime: "audio/basic" },
    { sufix: ".avi", mime: "video/avi" },
    { sufix: ".awf", mime: "application/vnd.adobe.workflow" },
    { sufix: ".biz", mime: "text/xml" },
    { sufix: ".bmp", mime: "application/x-bmp" },
    { sufix: ".bot", mime: "application/x-bot" },
    { sufix: ".c4t", mime: "application/x-c4t" },
    { sufix: ".c90", mime: "application/x-c90" },
    { sufix: ".cal", mime: "application/x-cals" },
    { sufix: ".cat", mime: "application/vnd.ms-pki.seccat" },
    { sufix: ".cdf", mime: "application/x-netcdf" },
    { sufix: ".cdr", mime: "application/x-cdr" },
    { sufix: ".cel", mime: "application/x-cel" },
    { sufix: ".cer", mime: "application/x-x509-ca-cert" },
    { sufix: ".cg4", mime: "application/x-g4" },
    { sufix: ".cgm", mime: "application/x-cgm" },
    { sufix: ".cit", mime: "application/x-cit" },
    { sufix: ".class", mime: "java/*" },
    { sufix: ".cml", mime: "text/xml" },
    { sufix: ".cmp", mime: "application/x-cmp" },
    { sufix: ".cmx", mime: "application/x-cmx" },
    { sufix: ".cot", mime: "application/x-cot" },
    { sufix: ".crl", mime: "application/pkix-crl" },
    { sufix: ".crt", mime: "application/x-x509-ca-cert" },
    { sufix: ".csi", mime: "application/x-csi" },
    { sufix: ".css", mime: "text/css" },
    { sufix: ".cut", mime: "application/x-cut" },
    { sufix: ".dbf", mime: "application/x-dbf" },
    { sufix: ".dbm", mime: "application/x-dbm" },
    { sufix: ".dbx", mime: "application/x-dbx" },
    { sufix: ".dcd", mime: "text/xml" },
    { sufix: ".dcx", mime: "application/x-dcx" },
    { sufix: ".der", mime: "application/x-x509-ca-cert" },
    { sufix: ".dgn", mime: "application/x-dgn" },
    { sufix: ".dib", mime: "application/x-dib" },
    { sufix: ".dll", mime: "application/x-msdownload" },
    { sufix: ".doc", mime: "application/msword" },
    { sufix: ".dot", mime: "application/msword" },
    { sufix: ".drw", mime: "application/x-drw" },
    { sufix: ".dtd", mime: "text/xml" },
    { sufix: ".dwf", mime: "Model/vnd.dwf" },
    { sufix: ".dwf", mime: "application/x-dwf" },
    { sufix: ".dwg", mime: "application/x-dwg" },
    { sufix: ".dxb", mime: "application/x-dxb" },
    { sufix: ".dxf", mime: "application/x-dxf" },
    { sufix: ".edn", mime: "application/vnd.adobe.edn" },
    { sufix: ".emf", mime: "application/x-emf" },
    { sufix: ".eml", mime: "message/rfc822" },
    { sufix: ".ent", mime: "text/xml" },
    { sufix: ".epi", mime: "application/x-epi" },
    { sufix: ".eps", mime: "application/x-ps" },
    { sufix: ".eps", mime: "application/postscript" },
    { sufix: ".etd", mime: "application/x-ebx" },
    { sufix: ".exe", mime: "application/x-msdownload" },
    { sufix: ".fax", mime: "image/fax" },
    { sufix: ".fdf", mime: "application/vnd.fdf" },
    { sufix: ".fif", mime: "application/fractals" },
    { sufix: ".fo", mime: "text/xml" },
    { sufix: ".frm", mime: "application/x-frm" },
    { sufix: ".g4", mime: "application/x-g4" },
    { sufix: ".gbr", mime: "application/x-gbr" },
    // .', mime: 'application/x-
    { sufix: ".gif", mime: "image/gif" },
    { sufix: ".gl2", mime: "application/x-gl2" },
    { sufix: ".gp4", mime: "application/x-gp4" },
    { sufix: ".hgl", mime: "application/x-hgl" },
    { sufix: ".hmr", mime: "application/x-hmr" },
    { sufix: ".hpg", mime: "application/x-hpgl" },
    { sufix: ".hpl", mime: "application/x-hpl" },
    { sufix: ".hqx", mime: "application/mac-binhex40" },
    { sufix: ".hrf", mime: "application/x-hrf" },
    { sufix: ".hta", mime: "application/hta" },
    { sufix: ".htc", mime: "text/x-component" },
    { sufix: ".htm", mime: "text/html" },
    { sufix: ".html", mime: "text/html" },
    { sufix: ".htt", mime: "text/webviewhtml" },
    { sufix: ".htx", mime: "text/html" },
    { sufix: ".icb", mime: "application/x-icb" },
    { sufix: ".ico", mime: "image/x-icon" },
    // { sufix: '.ico', mime: 'application/x-ico', },
    { sufix: ".iff", mime: "application/x-iff" },
    { sufix: ".ig4", mime: "application/x-g4" },
    { sufix: ".igs", mime: "application/x-igs" },
    { sufix: ".iii", mime: "application/x-iphone" },
    { sufix: ".img", mime: "application/x-img" },
    { sufix: ".ins", mime: "application/x-internet-signup" },
    { sufix: ".isp", mime: "application/x-internet-signup" },
    { sufix: ".IVF", mime: "video/x-ivf" },
    { sufix: ".java", mime: "java/*" },
    { sufix: ".jfif", mime: "image/jpeg" },
    { sufix: ".jpe", mime: "image/jpeg" },
    { sufix: ".jpe", mime: "application/x-jpe" },
    { sufix: ".jpeg", mime: "image/jpeg" },
    { sufix: ".jpg", mime: "image/jpeg" },
    { sufix: ".jpg", mime: "application/x-jpg" },
    // { sufix: '.js', mime: 'application/x-javascript', },
    { sufix: ".js", mime: "application/javascript" },
    { sufix: ".jsp", mime: "text/html" },
    { sufix: ".la1", mime: "audio/x-liquid-file" },
    { sufix: ".lar", mime: "application/x-laplayer-reg" },
    { sufix: ".latex", mime: "application/x-latex" },
    { sufix: ".lavs", mime: "audio/x-liquid-secure" },
    { sufix: ".lbm", mime: "application/x-lbm" },
    { sufix: ".lmsff", mime: "audio/x-la-lms" },
    { sufix: ".ls", mime: "application/x-javascript" },
    { sufix: ".ltr", mime: "application/x-ltr" },
    { sufix: ".m1v", mime: "video/x-mpeg" },
    { sufix: ".m2v", mime: "video/x-mpeg" },
    { sufix: ".m3u", mime: "audio/mpegurl" },
    { sufix: ".m4e", mime: "video/mpeg4" },
    { sufix: ".mac", mime: "application/x-mac" },
    { sufix: ".man", mime: "application/x-troff-man" },
    { sufix: ".math", mime: "text/xml" },
    { sufix: ".mdb", mime: "application/msaccess" },
    { sufix: ".mdb", mime: "application/x-mdb" },
    { sufix: ".mfp", mime: "application/x-shockwave-flash" },
    { sufix: ".mht", mime: "message/rfc822" },
    { sufix: ".mhtml", mime: "message/rfc822" },
    { sufix: ".mi", mime: "application/x-mi" },
    { sufix: ".mid", mime: "audio/mid" },
    { sufix: ".midi", mime: "audio/mid" },
    { sufix: ".mil", mime: "application/x-mil" },
    { sufix: ".mml", mime: "text/xml" },
    { sufix: ".mnd", mime: "audio/x-musicnet-download" },
    { sufix: ".mns", mime: "audio/x-musicnet-stream" },
    { sufix: ".mocha", mime: "application/x-javascript" },
    { sufix: ".movie", mime: "video/x-sgi-movie" },
    { sufix: ".mp1", mime: "audio/mp1" },
    { sufix: ".mp2", mime: "audio/mp2" },
    { sufix: ".mp2v", mime: "video/mpeg" },
    { sufix: ".mp3", mime: "audio/mp3" },
    { sufix: ".mp4", mime: "video/mpeg4" },
    { sufix: ".mpa", mime: "video/x-mpg" },
    { sufix: ".mpd", mime: "application/vnd.ms-project" },
    { sufix: ".mpe", mime: "video/x-mpeg" },
    { sufix: ".mpeg", mime: "video/mpg" },
    { sufix: ".mpg", mime: "video/mpg" },
    { sufix: ".mpga", mime: "audio/rn-mpeg" },
    { sufix: ".mpp", mime: "application/vnd.ms-project" },
    { sufix: ".mps", mime: "video/x-mpeg" },
    { sufix: ".mpt", mime: "application/vnd.ms-project" },
    { sufix: ".mpv", mime: "video/mpg" },
    { sufix: ".mpv2", mime: "video/mpeg" },
    { sufix: ".mpw", mime: "application/vnd.ms-project" },
    { sufix: ".mpx", mime: "application/vnd.ms-project" },
    { sufix: ".mtx", mime: "text/xml" },
    { sufix: ".mxp", mime: "application/x-mmxp" },
    { sufix: ".net", mime: "image/pnetvue" },
    { sufix: ".nrf", mime: "application/x-nrf" },
    { sufix: ".nws", mime: "message/rfc822" },
    { sufix: ".odc", mime: "text/x-ms-odc" },
    { sufix: ".out", mime: "application/x-out" },
    { sufix: ".p10", mime: "application/pkcs10" },
    { sufix: ".p12", mime: "application/x-pkcs12" },
    { sufix: ".p7b", mime: "application/x-pkcs7-certificates" },
    { sufix: ".p7c", mime: "application/pkcs7-mime" },
    { sufix: ".p7m", mime: "application/pkcs7-mime" },
    { sufix: ".p7r", mime: "application/x-pkcs7-certreqresp" },
    { sufix: ".p7s", mime: "application/pkcs7-signature" },
    { sufix: ".pc5", mime: "application/x-pc5" },
    { sufix: ".pci", mime: "application/x-pci" },
    { sufix: ".pcl", mime: "application/x-pcl" },
    { sufix: ".pcx", mime: "application/x-pcx" },
    { sufix: ".pdf", mime: "application/pdf" },
    { sufix: ".pdf", mime: "application/pdf" },
    { sufix: ".pdx", mime: "application/vnd.adobe.pdx" },
    { sufix: ".pfx", mime: "application/x-pkcs12" },
    { sufix: ".pgl", mime: "application/x-pgl" },
    { sufix: ".pic", mime: "application/x-pic" },
    { sufix: ".pko", mime: "application/vnd.ms-pki.pko" },
    { sufix: ".pl", mime: "application/x-perl" },
    { sufix: ".plg", mime: "text/html" },
    { sufix: ".pls", mime: "audio/scpls" },
    { sufix: ".plt", mime: "application/x-plt" },
    { sufix: ".png", mime: "image/png" },
    // { sufix: '.png', mime: 'application/x-png', },
    { sufix: ".pot", mime: "application/vnd.ms-powerpoint" },
    { sufix: ".ppa", mime: "application/vnd.ms-powerpoint" },
    { sufix: ".ppm", mime: "application/x-ppm" },
    { sufix: ".pps", mime: "application/vnd.ms-powerpoint" },
    { sufix: ".ppt", mime: "application/vnd.ms-powerpoint" },
    { sufix: ".ppt", mime: "application/x-ppt" },
    { sufix: ".pr", mime: "application/x-pr" },
    { sufix: ".prf", mime: "application/pics-rules" },
    { sufix: ".prn", mime: "application/x-prn" },
    { sufix: ".prt", mime: "application/x-prt" },
    { sufix: ".ps", mime: "application/x-ps" },
    { sufix: ".ps", mime: "application/postscript" },
    { sufix: ".ptn", mime: "application/x-ptn" },
    { sufix: ".pwz", mime: "application/vnd.ms-powerpoint" },
    { sufix: ".r3t", mime: "text/vnd.rn-realtext3d" },
    { sufix: ".ra", mime: "audio/vnd.rn-realaudio" },
    { sufix: ".ram", mime: "audio/x-pn-realaudio" },
    { sufix: ".ras", mime: "application/x-ras" },
    { sufix: ".rat", mime: "application/rat-file" },
    { sufix: ".rdf", mime: "text/xml" },
    { sufix: ".rec", mime: "application/vnd.rn-recording" },
    { sufix: ".red", mime: "application/x-red" },
    { sufix: ".rgb", mime: "application/x-rgb" },
    { sufix: ".rjs", mime: "application/vnd.rn-realsystem-rjs" },
    { sufix: ".rjt", mime: "application/vnd.rn-realsystem-rjt" },
    { sufix: ".rlc", mime: "application/x-rlc" },
    { sufix: ".rle", mime: "application/x-rle" },
    { sufix: ".rm", mime: "application/vnd.rn-realmedia" },
    { sufix: ".rmf", mime: "application/vnd.adobe.rmf" },
    { sufix: ".rmi", mime: "audio/mid" },
    { sufix: ".rmj", mime: "application/vnd.rn-realsystem-rmj" },
    { sufix: ".rmm", mime: "audio/x-pn-realaudio" },
    { sufix: ".rmp", mime: "application/vnd.rn-rn_music_package" },
    { sufix: ".rms", mime: "application/vnd.rn-realmedia-secure" },
    { sufix: ".rmvb", mime: "application/vnd.rn-realmedia-vbr" },
    { sufix: ".rmx", mime: "application/vnd.rn-realsystem-rmx" },
    { sufix: ".rnx", mime: "application/vnd.rn-realplayer" },
    { sufix: ".rp", mime: "image/vnd.rn-realpix" },
    { sufix: ".rpm", mime: "audio/x-pn-realaudio-plugin" },
    { sufix: ".rsml", mime: "application/vnd.rn-rsml" },
    { sufix: ".rt", mime: "text/vnd.rn-realtext" },
    { sufix: ".rtf", mime: "application/msword" },
    { sufix: ".rtf", mime: "application/x-rtf" },
    { sufix: ".rv", mime: "video/vnd.rn-realvideo" },
    { sufix: ".sam", mime: "application/x-sam" },
    { sufix: ".sat", mime: "application/x-sat" },
    { sufix: ".sdp", mime: "application/sdp" },
    { sufix: ".sdw", mime: "application/x-sdw" },
    { sufix: ".sit", mime: "application/x-stuffit" },
    { sufix: ".slb", mime: "application/x-slb" },
    { sufix: ".sld", mime: "application/x-sld" },
    { sufix: ".slk", mime: "drawing/x-slk" },
    { sufix: ".smi", mime: "application/smil" },
    { sufix: ".smil", mime: "application/smil" },
    { sufix: ".smk", mime: "application/x-smk" },
    { sufix: ".snd", mime: "audio/basic" },
    { sufix: ".sol", mime: "text/plain" },
    { sufix: ".sor", mime: "text/plain" },
    { sufix: ".spc", mime: "application/x-pkcs7-certificates" },
    { sufix: ".spl", mime: "application/futuresplash" },
    { sufix: ".spp", mime: "text/xml" },
    { sufix: ".ssm", mime: "application/streamingmedia" },
    { sufix: ".sst", mime: "application/vnd.ms-pki.certstore" },
    { sufix: ".stl", mime: "application/vnd.ms-pki.stl" },
    { sufix: ".stm", mime: "text/html" },
    { sufix: ".sty", mime: "application/x-sty" },
    { sufix: ".svg", mime: "text/xml" },
    { sufix: ".swf", mime: "application/x-shockwave-flash" },
    { sufix: ".tdf", mime: "application/x-tdf" },
    { sufix: ".tg4", mime: "application/x-tg4" },
    { sufix: ".tga", mime: "application/x-tga" },
    { sufix: ".tif", mime: "image/tiff" },
    { sufix: ".tif", mime: "application/x-tif" },
    { sufix: ".tiff", mime: "image/tiff" },
    { sufix: ".tld", mime: "text/xml" },
    { sufix: ".top", mime: "drawing/x-top" },
    { sufix: ".torrent", mime: "application/x-bittorrent" },
    { sufix: ".tsd", mime: "text/xml" },
    { sufix: ".txt", mime: "text/plain" },
    { sufix: ".uin", mime: "application/x-icq" },
    { sufix: ".uls", mime: "text/iuls" },
    { sufix: ".vcf", mime: "text/x-vcard" },
    { sufix: ".vda", mime: "application/x-vda" },
    { sufix: ".vdx", mime: "application/vnd.visio" },
    { sufix: ".vml", mime: "text/xml" },
    { sufix: ".vpg", mime: "application/x-vpeg005" },
    { sufix: ".vsd", mime: "application/vnd.visio" },
    { sufix: ".vsd", mime: "application/x-vsd" },
    { sufix: ".vss", mime: "application/vnd.visio" },
    { sufix: ".vst", mime: "application/vnd.visio" },
    { sufix: ".vst", mime: "application/x-vst" },
    { sufix: ".vsw", mime: "application/vnd.visio" },
    { sufix: ".vsx", mime: "application/vnd.visio" },
    { sufix: ".vtx", mime: "application/vnd.visio" },
    { sufix: ".vxml", mime: "text/xml" },
    { sufix: ".wav", mime: "audio/wav" },
    { sufix: ".wax", mime: "audio/x-ms-wax" },
    { sufix: ".wb1", mime: "application/x-wb1" },
    { sufix: ".wb2", mime: "application/x-wb2" },
    { sufix: ".wb3", mime: "application/x-wb3" },
    { sufix: ".wbmp", mime: "image/vnd.wap.wbmp" },
    { sufix: ".webp", mime: "image/webp" },
    { sufix: ".wiz", mime: "application/msword" },
    { sufix: ".wk3", mime: "application/x-wk3" },
    { sufix: ".wk4", mime: "application/x-wk4" },
    { sufix: ".wkq", mime: "application/x-wkq" },
    { sufix: ".wks", mime: "application/x-wks" },
    { sufix: ".wm", mime: "video/x-ms-wm" },
    { sufix: ".wma", mime: "audio/x-ms-wma" },
    { sufix: ".wmd", mime: "application/x-ms-wmd" },
    { sufix: ".wmf", mime: "application/x-wmf" },
    { sufix: ".wml", mime: "text/vnd.wap.wml" },
    { sufix: ".wmv", mime: "video/x-ms-wmv" },
    { sufix: ".wmx", mime: "video/x-ms-wmx" },
    { sufix: ".wmz", mime: "application/x-ms-wmz" },
    { sufix: ".wp6", mime: "application/x-wp6" },
    { sufix: ".wpd", mime: "application/x-wpd" },
    { sufix: ".wpg", mime: "application/x-wpg" },
    { sufix: ".wpl", mime: "application/vnd.ms-wpl" },
    { sufix: ".wq1", mime: "application/x-wq1" },
    { sufix: ".wr1", mime: "application/x-wr1" },
    { sufix: ".wri", mime: "application/x-wri" },
    { sufix: ".wrk", mime: "application/x-wrk" },
    { sufix: ".ws", mime: "application/x-ws" },
    { sufix: ".ws2", mime: "application/x-ws" },
    { sufix: ".wsc", mime: "text/scriptlet" },
    { sufix: ".wsdl", mime: "text/xml" },
    { sufix: ".wvx", mime: "video/x-ms-wvx" },
    { sufix: ".xdp", mime: "application/vnd.adobe.xdp" },
    { sufix: ".xdr", mime: "text/xml" },
    { sufix: ".xfd", mime: "application/vnd.adobe.xfd" },
    { sufix: ".xfdf", mime: "application/vnd.adobe.xfdf" },
    { sufix: ".xhtml", mime: "text/html" },
    { sufix: ".xls", mime: "application/vnd.ms-excel" },
    { sufix: ".xls", mime: "application/x-xls" },
    { sufix: ".xlw", mime: "application/x-xlw" },
    { sufix: ".xml", mime: "text/xml" },
    { sufix: ".xpl", mime: "audio/scpls" },
    { sufix: ".xq", mime: "text/xml" },
    { sufix: ".xql", mime: "text/xml" },
    { sufix: ".xquery", mime: "text/xml" },
    { sufix: ".xsd", mime: "text/xml" },
    { sufix: ".xsl", mime: "text/xml" },
    { sufix: ".xslt", mime: "text/xml" },
    { sufix: ".xwd", mime: "application/x-xwd" },
    { sufix: ".x_b", mime: "application/x-x_b" },
    { sufix: ".sis", mime: "application/vnd.symbian.install" },
    { sufix: ".sisx", mime: "application/vnd.symbian.install" },
    { sufix: ".x_t", mime: "application/x-x_t" },
    { sufix: ".ipa", mime: "application/vnd.iphone" },
    { sufix: ".apk", mime: "application/vnd.android.package-archive" },
    { sufix: ".xap", mime: "application/x-silverlight-app" },
    { sufix: ".map", mime: "application/json" },
]
const mimeDic = new Map<string, any>()
for (let i = 0; i < mimeArr.length; i += 1) {
    const key = mimeArr[i].sufix
    mimeDic.set(key, mimeArr[i].mime)
}
const mimeTransfer = {
    getTypeByUrl(url: string) {
        let matches = url.match(/\.[^/^?^.]{1,}$/)

        let sufix = ""
        if (matches && matches.length > 0) {
            const [_sufix] = matches
            sufix = _sufix
        } else {
            matches = url.match(/(\.[^/^?^.]{1,})\?/)

            if (matches && matches.length > 1) {
                const [, _sufix] = matches
                sufix = _sufix
            }
        }

        if (sufix && mimeDic.get(sufix)) {
            return mimeDic.get(sufix)
        }
        if (sufix && !mimeDic.get(sufix)) {
            // 不考虑 接口代理的情况
            return ""
        }

        return "text/html"
    },
}

export default mimeTransfer
