// 混淆器
import { CONSTS_MIXED_WORDS } from "../constant"

// 混淆偏移位置
const desc = 2

function randomStringAdd(str: string, _desc: number) {
    const words = CONSTS_MIXED_WORDS
    let result = ""
    for (let i = 0; i < str.length; i += _desc) {
        const rand = words[Math.floor(Math.random() * words.length)]
        result += str.substring(i, i + _desc)
        if (i + _desc <= str.length) {
            result += rand
        }
    }
    return result
}
/**
 * 加混淆
 * */
export function AddConfusion(str: string) {
    return randomStringAdd(str, desc)
}
/**
 *
 * @param {待解密字符串} str
 * @param {混淆偏移位置} desc
 * @returns
 */
function correctCodeGet(str: string, _desc: number) {
    const strArr = str.split("")
    const codeArr: any[] = []
    strArr.forEach((item, index) => {
        if ((index + 1) % (_desc + 1) !== 0) {
            codeArr.push(item)
        }
    })
    const result = codeArr.join("")
    return result
}
/**
 * 解混淆
 */
export function Disambiguation(str: string) {
    return correctCodeGet(str, desc)
}
